<?php

namespace Drupal\printjs;

/**
 * Service to get button printjs.
 */
class Printjs {

  /**
   * Method get button print js.
   *
   * {@inheritDoc}
   */
  public function getBtnPrintjs(string $printText = 'Print', $config = []) {
    $configuration = [];
    if (empty($config)) {
      $config = \Drupal::config('printjs.settings');
    }
    if (is_object($config)) {
      $configuration = $config->getRawData();
    }
    elseif (is_array($config)) {
      $configuration = $config;
    }
    $attributes = [
      'class' => [
        'btn-print',
        'btn',
        'btn-success',
      ],
      'data-type' => 'html',
      'data-printable' => 'print',
    ];
    if (!empty($attr)) {
      foreach ($attr as $key => $attribute) {
        $attributes[$key] = $attribute;
      }
    }
    return [
      '#theme' => 'printjs',
      '#printText' => t('@text', ['@text' => $printText]),
      '#attributes' => $attributes,
      '#attached' => [
        'library' => ['printjs/printjs'],
        'drupalSettings' => ['printjs' => $configuration],
      ],
    ];
  }

}
